Package org.apache.uima.collection.metadata

# Interface CpeComponentDescriptor

All Superinterfaces:
  `Cloneable`, `MetaDataObject`, `Serializable`, `XMLizable`

public interface CpeComponentDescriptor extends MetaDataObject
An object that holds configuration that is part of the CPE descriptor. Provides the means of setting component descriptor file path containing configuration

- ## Method Summary

  Modifier and Type
  Method
  Description
  `URL`
  `findAbsoluteUrl(ResourceManager aResourceManager)`
  Returns the absolute URL where the component descriptor is located.
  `Import`
  `getImport()`
  Gets the Import object that declares where the component descriptor is located.
  `CpeInclude`
  `getInclude()`
  Returns component's descriptor file path
  `void`
  `setImport(Import aImport)`
  Sets the Import object that declares where the component descriptor is located.
  `void`
  `setInclude(CpeInclude aInclude)`
  Sets component's descriptor file path

  ### Methods inherited from interface org.apache.uima.resource.metadata.MetaDataObject

  `clone, equals, getAttributeValue, getSourceUrl, getSourceUrlString, isModifiable, listAttributes, setAttributeValue, setSourceUrl`

  ### Methods inherited from interface org.apache.uima.util.XMLizable

  `buildFromXMLElement, buildFromXMLElement, toXML, toXML, toXML, toXML`

- ## Method Details

  - ### setInclude

    void setInclude(CpeInclude aInclude)
    Sets component's descriptor file path
    Parameters:
      `aInclude` - - `CpeInclude` containing file path

  - ### getInclude

    CpeInclude getInclude()
    Returns component's descriptor file path
    Returns:
      `CpeInclude`

  - ### getImport

    Import getImport()
    Gets the Import object that declares where the component descriptor is located. Import objects support locating the component descriptor either using a path that's relative to the CPE descriptor's location ("import by location") or using the classpath/datapath ("import by name").
    Returns:
      the import, null if none

  - ### setImport

    void setImport(Import aImport)
    Sets the Import object that declares where the component descriptor is located. Import objects support locating the component descriptor either using a path that's relative to the CPE descriptor's location ("import by location") or using the classpath/datapath ("import by name").
    Parameters:
      `aImport` - the import, null if none

  - ### findAbsoluteUrl

    URL findAbsoluteUrl(ResourceManager aResourceManager) throws ResourceConfigurationException
    Returns the absolute URL where the component descriptor is located. This will use either the include or import property, whichever is specified.
    Parameters:
      `aResourceManager` - resource manager to use to do import-by-name lookups
    Returns:
      the absolute URL of the component descriptor
    Throws:
      `ResourceConfigurationException` - if an import could not be resolved